(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***         Portions Copyright (c) 2002 by Eugen Honeker (see below)       ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/  e.honeker@vclfree.de ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                       Privet iz Germanij                               ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeata Magica, Kurtzweyl, Manowar,    ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- & Eugen Honeker ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

(******************************************************************************

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !! EN_DIS_ABLE has been renamed with version 2.60d -> It is called EDA now.!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  Abstract:
  ---------
  This program was intentionally designed to show some nonVCL techniques.
  But finally I decided to improve it more and more. Now it can IMO compete with
  the so called "Window finder" function of Microsoft Spy++ (from MS Visual
  Studio).
  EDA does not only allow you to modify the behavior of applications at runtime
  (to just a certain extent), it also provides you with detailed informations
  about the window you select. You may see the class name of the window, certain
  handle values, styles, coordinates et cetera.
  First I thought to introduce code that is not based on a window hook will fail
   - but since one draws on the window only as long as the current window has
   the mouse input and refreshes afterwards - the expectation proved wrong.
  +--------------------------------------------------------------------------+
  | Please note, that I am very proud that version 2.50a of this program was |
  | included on a shareware/freeware collection CD of a very famous German   |
  | magazine on Computer Technologies (c't -> http://www.heise.de/ct).       |
  | You will also find this tool at several other sites in various versions. |
  | So, to get the latest version always navigate to my home page.           |
  | The download URL will be valid, as long as I own the domain assarbad.org |
  +--------------------------------------------------------------------------+

  Eugen's part in this work:
  --------------------------
  Eugen contributed what's in the ".\Include\EugensFuncs.pas" plus the Format()
  function. The Format() function is compatible with that one in SysUtils.pas,
  except that it can only handle strings up to 1024 characters, where the one in
  SysUtils.pas can handle virtually up to 2^32-1 characters. He also suggested
  and implemented the "Always on top" functionality.

  Download:
  ---------
  Old versions can still be found at:
          [my page]/stuff/oldstuff.zip
  Version [current] can be found at:
          [my page]/stuff/enable_disable.zip

  As of this writing:
          [my page]        = http://assarbad.org
          [Eugen's page]   = http://www.vclfree.de
          [currentversion] = 2.60e1

  For version history see history.txt in the .\SOURCE directory!
 ******************************************************************************)

program EDA;
uses
  Windows,
  Commdlg,
  CommCtrl,
  Messages,
  ScreenShot in '.\ScreenShotUnit\ScreenShot.pas'
  ;

{$R main.res} // dialogs and icon
{$R help.res} // help texts

{DEFINE DEBUGGING}
(* During debugging - default = OFF *)
{$DEFINE AssasSelectionStyle}
(* Hope it is better visible and more common - default = ON *)
{$DEFINE AssasRedrawScheme}
(* Eugen's was not sufficient, mine was not before 2.5pre1 - default = ON *)

var
  blackbrush,
    greenbrush: HBRUSH;
  appicon,
    NormIcon,
    DragIcon: HICON;
  arrow_cursor,
    target_cursor: HCURSOR;
  hwndlast,
    maindlg: HWND;
  fix_sym: HFONT; //help dlg
  globrefpointer: Pointer;
  notXP,
    passhk_active,
    capthk_active: boolean;

var
  osvi: TOSVersionInfo =
  (
    dwOSVersionInfoSize: sizeof(TOSVersionInfo)
    );

// initialised brush-structures - need handles only
  BlackBrushTemplate: TLogBrush =
  (
    lbStyle: BS_SOLID;
    lbColor: $00000000;
    lbHatch: 0
    );

  GreenBrushTemplate: TLogBrush =
  (
    lbStyle: BS_SOLID;
    lbColor: $0000FF00;
    lbHatch: 0
    );

  RedBrushTemplate: TLogBrush =
  (
    lbStyle: BS_SOLID;
    lbColor: $000000FF;
    lbHatch: 0
    );

type
  PMiscData = ^TMiscData;
  TMiscData = record
    target_handle,
      target_workhandle,
      target_parenthandle: HWND;
    target_assoctext,
      target_classname: PChar;
    target_Instance: hInst;
    target_menuhandle,
      target_ctrlid,
      target_style,
      target_exstyle,
      target_wndproc,
      target_PID,
      target_TID: Cardinal;
    target_icon_big,
      target_icon_small: HICON;
    target_madevisible,
      target_isvisible,
      target_isunicode,
      target_isenabled: boolean;
    target_windowrect,
      target_clientrect: TRect;
    target_classstyle: Cardinal;
    Autocopy2Clip: Boolean;
  end;

  PPropertylist = ^TPropertylist;
  TPropertylist = record
    name_of_prop,
      val_if_sz: PChar;
    value,
      pointsto: Cardinal;
    assigned_ref: boolean;
    lastentry: PPropertylist;
    nextentry: PPropertylist;
  end;

var
  listentry: PPropertyList = nil; // entry point to the list
  lastentry: PPropertyList = nil; // last entry point of the list

{$INCLUDE .\Include\Compilerswitches.pas}
{$INCLUDE .\Include\Delphi3compat.pas}
{$INCLUDE .\Include\Constants.pas}
{$INCLUDE .\Include\FormatString.pas}
{$INCLUDE .\Include\GetFont.pas}
{$INCLUDE .\Include\ReUsables.pas}
{$INCLUDE .\Include\MiscData.pas}
{$INCLUDE .\Include\StatusHint.pas}
{$INCLUDE .\Include\PrivEnable_KillProc.pas}
{$INCLUDE .\Include\Help_DlgFunc.pas}
{$INCLUDE .\Include\Property_DlgFunc.pas}
{$INCLUDE .\Include\Styles_DlgFunc.pas}
{$INCLUDE .\Include\About_DlgFunc.pas}
{$INCLUDE .\Include\EugensFuncs.pas}
{$INCLUDE .\Include\ScreenCapture.pas}

function dlgfunc(hwnd: HWND; umsg: Cardinal; wparam: WPARAM; lparam: LPARAM): BOOL; stdcall;
(*
  This is the main dialog's callback function.
*)
var
  target: THandle;
  pt: TPoint;
  hSysMenu: HMENU;
  miscd: PMiscData;

  function RestrictModify(trgt: Windows.HWND): boolean;
    (*
      This only works with first class children ... grandchildren etc could not
      be catched by this approach.
      Since we try to get out wether the window is child of this dialog
    *)
  var
    enable: boolean;
    dummy_PID: DWORD;
  begin
    enable := not (GetWindowThreadProcessId(trgt, @dummy_PID) = GetCurrentThreadID);
    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_MINIMIZE_RESTORE), enable);
    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_CLOSETARGETWINDOW), enable);
    EnableWindow(GetDlgItem(hwnd, IDC_CHECK_ISENABLED), enable);
    EnableWindow(GetDlgItem(hwnd, IDC_CHECK_ISVISIBLE), enable);
    result := not enable;
  end;

begin
  Result := TRUE;
  case umsg of
    WM_INITDIALOG:
      begin
// XP uses the small icon ;) ... previous versions the big one ...
// at least it seems to be that way
        InitMiscData;
        maindlg := hwnd;
// hook the mouse
        InitHints;
        SendMessage(hwnd, WM_SETTEXT, 0, Integer(@captiontext[1]));
        SendMessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        SendMessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
// Add "always on top" to system menu
        hSysMenu := GetSystemMenu(hWnd, False);
        AppendMenu(hSysMenu, MF_SEPARATOR, 0, nil);
        AppendMenu(hSysMenu, MF_BYPOSITION, SC_TOPMOST, @sz_topmost[1]);
// set text of status button control
        SetDlgItemText(hwnd, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_STATUS[1]);
// get font handle
        fix8 := GetFont(hwnd, 8, FW_NORMAL, true);
        fix10 := GetFont(hwnd, 10, FW_NORMAL, true);
// set fixed font to all wanted controls
        sendmessage(Getdlgitem(hwnd, IDOK), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_PID), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_TID), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_WNDHANDLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_CTRLID), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_WNDPROC), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_MENUNAME), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_ICONHANDLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_ICONSMHANDLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_INSTANCE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_PARENTWND), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_STYLE), WM_SETFONT, fix10, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON_EXSTYLE), WM_SETFONT, fix10, ord(TRUE));
        SetProp(Getdlgitem(hwnd, IDC_BUTTON_STATUS), @testproperty_name[1], integer(@testproperty[1]));
        SetProp(Getdlgitem(hwnd, IDC_BUTTON_STATUS), @testproperty_name2[1], integer(@testproperty2[1]));
// register hotkey for unmasking passwords
        passhk_active := true;
        if RegisterHotKey(hwnd, HOTKEY_PASSVIS, MOD_WIN, HOTKEY_PASSVIS) then
          szPW_hotkey := hintadd_hotkey_pw_desc + hintadd_prefix_winkey + hintadd_hotkey_pw
        else
          if RegisterHotKey(hwnd, HOTKEY_PASSVIS, MOD_CONTROL or MOD_ALT, HOTKEY_PASSVIS) then
            szPW_hotkey := hintadd_hotkey_pw_desc + hintadd_prefix_altctrl + hintadd_hotkey_pw
          else
            passhk_active := false;
// register hotkey for capturing target window content
        capthk_active := true;
        if RegisterHotKey(hwnd, HOTKEY_CAPTURE, MOD_WIN, HOTKEY_CAPTURE) then
          szSC_hotkey := hintadd_hotkey_capt_desc + hintadd_prefix_winkey + hintadd_hotkey_capt
        else
          if RegisterHotKey(hwnd, HOTKEY_CAPTURE, MOD_CONTROL or MOD_ALT, HOTKEY_CAPTURE) then
            szSC_hotkey := hintadd_hotkey_capt_desc + hintadd_prefix_altctrl + hintadd_hotkey_capt
          else
            capthk_active := false;
        SetCheckBox(hwnd, IDC_CHECK_COPYCLIP, True);
        SetCheckBox(hwnd, IDC_CHECK_MAKEVIS, True);
      end;
    WM_CLOSE:
      begin
// unhook the mouse
        DeinitHints;
        DeInitMiscData;
        DeleteObject(fix8);
        DeleteObject(fix10);
        PostQuitMessage(0);
// close the dialog and clean up
        EndDialog(hwnd, 0);
      end;
    WM_CTLCOLORSTATIC:
// Note, that the text of 3D checkboxes and also READONLY EDIT controls seem
// to get their color from the font color you set here for the DC of the
// respective windows
      case GetDlgCtrlID(lParam) of
        IDC_EDIT_ASSOCTEXT:
          begin
            SetBkColor(wParam, BlackBrushTemplate.lbColor);
            SetTextColor(wParam, $0000FF00);
            result := BOOL(blackbrush);
          end;
        IDC_STATIC_PID,
          IDC_STATIC_TID:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00CC0000);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_STATIC_CLASSNAME:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00000088);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_STATIC_WINDOWRECT,
          IDC_STATIC_CLIENTRECT,
          IDC_STATIC_PARENTWND:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00006600);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_STATIC_TARGHINT:
        begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, RGB($88,$88,$88));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
        end;
      else
        begin
          SetBkMode(wParam, TRANSPARENT);
          SetTextColor(wParam, $00660000);
          result := BOOL(GetSysColorBrush(COLOR_3DFACE));
        end;
      end;
    WM_LBUTTONDOWN:
      begin
        pt.x := LoWord(lParam);
        pt.y := HiWord(lParam);
        if childwindowfrompoint(hwnd, pt) = getdlgitem(hwnd, IDC_TARGETER) then
        begin
          setcapture(hwnd);
          setcursor(target_cursor);
          miscd := GlobRefPointer;
          miscd^.Autocopy2Clip := GetCheckBox(hwnd, IDC_CHECK_COPYCLIP);
          SendMessage(Getdlgitem(hwnd, IDC_TARGETER), STM_SETIMAGE, IMAGE_ICON, DragIcon);
        end
        else
          if notXP then
            sendmessage(hwnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam);
      end;
    WM_MOUSEMOVE:
      if GetCapture = hwnd then
        if Getcursorpos(pt) then
        begin
// Get target window handle
// This is based on enumeration of child windows
          target := RealWindowFromPoint(pt);
// Get data structure which holds everything
          miscd := globrefpointer;
// restrict the modification of own controls
          RestrictModify(miscd^.target_handle);
// refresh only if different handle
          if miscd^.target_workhandle <> target then
          begin
            if miscd^.target_madevisible then
// Remove WS_VISIBLE style, if _we_ added it!
              ShowWindow(miscd^.target_workhandle, SW_HIDE);
            hwndlast := miscd^.target_workhandle;
{$IFDEF AssasRedrawScheme}
            if miscd^.target_workhandle <> 0 then
              UnSelectWindow(miscd^.target_workhandle);
{$ELSE AssasRedrawScheme}
            if miscd^.target_handle <> 0 then
              SelectWindow(miscd^.target_handle);
{$ENDIF AssasRedrawScheme}
// Fill our structure with the necessary data
            FillMiscData(miscd, target);
// Show the gathered data ;)
            ShowMiscData(hwnd);
// copy text to clipboard if desired ;)
            if miscd^.Autocopy2Clip then
              CopyText2ClipBoard(hwnd, miscd^.target_assoctext);
// If wanted make the window visible on selection!
            if GetCheckBox(hwnd, IDC_CHECK_MAKEVIS) then
              if not MyIsWindowVisible(target) then
              begin
                ShowWindow(target, SW_SHOW);
                MyUpdateWindow(target);
                miscd^.target_madevisible := true;
              end
              else
                miscd^.target_madevisible := false;
// Finally draw "selected" frame ... because childs redraw before
            SelectWindow(miscd^.target_workhandle);
          end;
        end;
    WM_DRAWITEM: //Eugens idea ...
      begin
        with PDRAWITEMSTRUCT(lParam)^ do
          case CtlID of
            IDC_BUTTON_KILLTARGETPROCESS:
              begin
                if (itemState and ODS_SELECTED) = 0 then
                  DrawFrameControl(hDC, rcItem, DFC_CAPTION, DFCS_CAPTIONCLOSE)
                else
                  DrawFrameControl(hDC, rcItem, DFC_CAPTION, DFCS_PUSHED or DFCS_CAPTIONCLOSE);
                if (itemState and ODS_FOCUS) <> 0 then
                begin
                  InflateRect(rcItem, -2, -2);
                  DrawFocusRect(hDC, rcItem);
                end;
              end;
          end;
      end;
    WM_LBUTTONUP:
      if GetCapture = hwnd then
        ReleaseCapture;
    WM_CAPTURECHANGED:
      begin
        miscd := globrefpointer;
        setcursor(arrow_cursor);
        senddlgitemmessage(hwnd, IDC_TARGETER, STM_SETIMAGE, IMAGE_ICON, normicon);
        if miscd^.target_madevisible then
// Remove WS_VISIBLE style, if _we_ added it!
          ShowWindow(miscd^.target_handle, SW_HIDE);
{$IFDEF AssasRedrawScheme}
        if miscd^.target_workhandle <> 0 then
          UnSelectWindow(miscd^.target_workhandle);
{$ELSE AssasRedrawScheme}
        if miscd^.target_workhandle <> 0 then
          SelectWindow(miscd^.target_workhandle);
{$ENDIF AssasRedrawScheme}
        miscd^.target_workhandle := 0;
      end;
    WM_HOTKEY:
      case wParam of
        HOTKEY_CAPTURE:
// if we registered this hotkey, do the job - might be obsolete
          case capthk_active of
            true:
              begin
                miscd := globrefpointer;
                if WndCapture(hwnd, miscd^.target_handle) then
                  Windows.Beep(200, 50)
              end;
          end;
        HOTKEY_PASSVIS:
// if we registered this hotkey, do the job - might be obsolete
          case passhk_active of
            true:
              begin
                miscd := globrefpointer;
                if IsWindow(miscd^.target_handle) then
                begin
// ROFL Sendmessage does not work, but Postmessage() does.
// This is real protection
                  Postmessage(miscd^.target_handle, EM_SETPASSWORDCHAR, 0, 0);
// Set and unset readonly style - this also implies a visual
// change and thus the control will redraw
                  PostMessage(miscd^.target_handle, EM_SETREADONLY, ord(true), 0);
                  PostMessage(miscd^.target_handle, EM_SETREADONLY, 0, 0);
                  Windows.Beep(200, 100);
                end;
              end;
          end;
      end;
    WM_COMMAND:
// Handle all button clicks et cetera
      if HiWord(WParam) = BN_CLICKED then
        case LOWORD(wParam) of
          IDC_BUTTON_CLOSETARGETWINDOW:
// Close window
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
                postmessage(miscd^.target_handle, WM_CLOSE, 0, 0);
            end;
          IDC_BUTTON_MINIMIZE_RESTORE:
// Minimize / Restore
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
                if IsIconic(miscd^.target_handle) then
                  Showwindow(miscd^.target_handle, SW_RESTORE)
                else
                  Showwindow(miscd^.target_handle, SW_MINIMIZE);
            end;
          IDC_BUTTON_KILLTARGETPROCESS:
// Kill target process
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
                if RestrictModify(miscd^.target_handle) then
// If we are to be killed just close self opposed to suicide ;)
                  SendMessage(hwnd, WM_CLOSE, 0, 0)
                else
                  if not KillProcess(miscd^.target_PID) then
// If process could not be killed show error box
                    messagebox(hwnd, @err_gotnokill[1], nil, 0);
            end;
          IDC_BUTTON_STATUS:
            DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_ABOUT), hwnd, @about_dlgfunc);
          IDC_BUTTON_WNDPROPS:
            DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_WNDPROPS), hwnd, @wprops_dlgfunc);
          IDC_BUTTON_STYLE,
            IDC_BUTTON_EXSTYLE:
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
                if (miscd^.target_style <> 0) or (miscd^.target_exstyle <> 0) then
                  DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_WSTYLES), hwnd, @wstyles_dlgfunc);
            end;
          IDC_CHECK_ISENABLED:
// Target window enabled?
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
              begin
                EnableWindow(miscd^.target_handle, not IsWindowEnabled(miscd^.target_handle));
                if IsWindowEnabled(miscd^.target_handle) then
                  CheckDlgButton(hwnd, IDC_CHECK_ISENABLED, BST_CHECKED)
                else
                  CheckDlgButton(hwnd, IDC_CHECK_ISENABLED, BST_UNCHECKED);
              end;
            end;
// IDC_CHECK2 (Unicode) is fully handled by WM_MOUSEMOVE, it's dead
// and non-automatic
          IDC_CHECK_ISVISIBLE:
// Target window visible?
            begin
              miscd := globrefpointer;
              if IsWindow(miscd^.target_handle) then
                if IsWindowVisible(miscd^.target_handle) then
                  ShowWindow(miscd^.target_handle, SW_HIDE)
                else
                  ShowWindow(miscd^.target_handle, SW_SHOWNOACTIVATE);
              if IsWindowVisible(miscd^.target_handle) then
                CheckDlgButton(hwnd, IDC_CHECK_ISVISIBLE, BST_CHECKED)
              else
                CheckDlgButton(hwnd, IDC_CHECK_ISVISIBLE, BST_UNCHECKED);
            end;
        end;
// If the system menu is called and the SC_TOPMOST menu item is selected
    WM_SYSCOMMAND:
      case wParam of
        SC_CONTEXTHELP: DialogBoxParam(hInstance, MAKEINTRESOURCE(DIALOG_HELP), hwnd, @help_dlgfunc, 0);
        SC_TOPMOST: SetWindowTopMost(hWnd, not IsTopMost(hWnd));
      else
        Result := false;
      end;
// Put the SC_TOPMOST state into visual appearance (checked if ontop)
    WM_INITMENUPOPUP:
      if BOOL(HIWORD(lParam)) then
        if IsTopMost(hWnd) then
          CheckMenuItem(GetSystemMenu(hWnd, False), SC_TOPMOST, MF_CHECKED)
        else
          CheckMenuItem(GetSystemMenu(hWnd, False), SC_TOPMOST, MF_UNCHECKED);
  else
    result := false;
  end;
end;

(*
  Main() function of the module ;)
*)
begin
  notXP := false;
  if GetVersionEx(osvi) then
    notXP := not ((osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) and (osvi.dwPlatformId = VER_PLATFORM_WIN32_NT));
// Load Icons
  DragIcon := LoadIcon(hInstance, MAKEINTRESOURCE(ICON1));
  NormIcon := LoadIcon(hInstance, MAKEINTRESOURCE(ICON2));
  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(1));
// Load Cursor
  target_cursor := loadcursor(hInstance, MAKEINTRESOURCE(DRAGCURSOR));
  arrow_cursor := loadcursor(hinstance, IDC_ARROW);
// Init brush ;)
  blackbrush := CreateBrushIndirect(BlackBrushTemplate);
  greenbrush := CreateBrushIndirect(GreenBrushTemplate);
// not really needed, but responsible for XP styles ...
  InitCommonControls;
// Show main window
  DialogBoxParam(hInstance, MAKEINTRESOURCE(DIALOG_MAIN), 0, @dlgfunc, 0);
// Do this or rely on Windows doing it ;) ... I do it myself =)
  DeleteObject(blackbrush);
  DeleteObject(greenbrush);
// This is definitely obsolete, but memproof and "other" pushed me to do this
  DestroyCursor(target_cursor);
  (* DestroyCursor(arrow_cursor); -> This is a Windows shared cursor! *)
  DestroyIcon(DragIcon);
  DestroyIcon(NormIcon);
  DestroyIcon(AppIcon);
end.

