(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***                                                                        ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                       Privet iz Germanij                               ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

procedure FillMiscData(miscd: PMiscData; target: HWND);
(*
  Functionality:
    Fills the structure which pointer is given with the respective parameters of
    the target window.
    [SPECIFIC]
*)
var
i:integer;
temps:string;
begin
  miscd^.target_handle := target;
  miscd^.target_workhandle := miscd^.target_handle;
  temps:=GetClassNameFromWnd(miscd^.target_handle);
  if Assigned(miscd^.target_classname) then
    FreeMemory(miscd^.target_classname);
  i:=length(temps)+1;
  miscd^.target_classname:=GetMemory(i);
  if Assigned(miscd^.target_classname) then
  try
    ZeroMemory(miscd^.target_classname, i);
    lstrcpy(miscd^.target_classname, @temps[1]);
  except
    FreeMemory(miscd^.target_classname);
    miscd^.target_classname:=nil;
  end;
  temps:=GetTextFromWnd(miscd^.target_handle);
  i:=length(temps)+1;
  miscd^.target_assoctext:=GetMemory(i);
  if Assigned(miscd^.target_assoctext) then
  try
    ZeroMemory(miscd^.target_assoctext, i);
    lstrcpy(miscd^.target_assoctext, @temps[1]);
  except
    FreeMemory(miscd^.target_assoctext);
    miscd^.target_assoctext:=nil;
  end;
  miscd^.target_parenthandle := GetWindowLong(miscd^.target_handle, GWL_HWNDPARENT);
  miscd^.target_ctrlid := GetDlgCtrlID(miscd^.target_handle);
  miscd^.target_wndproc := GetWindowLong(miscd^.target_handle, GWL_WNDPROC);
  miscd^.target_menuhandle := GetMenu(miscd^.target_handle);
  miscd^.target_style := GetWindowLong(miscd^.target_handle, GWL_STYLE);
  miscd^.target_exstyle := GetWindowLong(miscd^.target_handle, GWL_EXSTYLE);
  miscd^.target_classstyle := GetClassLong(miscd^.target_handle, GCL_STYLE);
  miscd^.target_Instance := GetWindowLong(miscd^.target_handle, GWL_HINSTANCE);
  miscd^.target_icon_big := SendMessage(miscd^.target_handle, WM_GETICON, ICON_BIG, 0);
  miscd^.target_icon_small := SendMessage(miscd^.target_handle, WM_GETICON, ICON_SMALL, 0);
  miscd^.target_isenabled := IsWindowEnabled(miscd^.target_handle);
  miscd^.target_isunicode := IsWindowUnicode(miscd^.target_handle);
  miscd^.target_isvisible := IsWindowVisible(miscd^.target_handle);
  miscd^.target_TID := GetWindowThreadProcessID(miscd^.target_handle, @miscd^.target_PID);
  GetWindowRect(miscd^.target_handle, miscd^.target_windowrect);
  GetClientRect(miscd^.target_handle, miscd^.target_clientrect);
  RemovePropertyList;
  EnumPropsEx(miscd^.target_handle, @PropEnumProcEx, 0);
end;

procedure ShowMiscData(dialog: HWND);
(*
  Functionality:
    This function shows the data gathered by FillMiscData()
    [SPECIFIC]

  Note, that this procedure is very specific to the dialog, that is used by
  EN_DIS_ABLE - it is not re-usable, without changing the target controls, that
  receive the respective text!
*)
var
  miscd: PMiscData;
begin
  miscd := globrefpointer;
  //------------------------------------------------------------------------------
  SetDlgItemText(dialog, IDC_EDIT_ASSOCTEXT, @miscd^.target_assoctext[0]);
  SetDlgItemText(dialog, IDC_BUTTON_STYLE,
  @Format(hex_frmt +#13+ hex_frmt +#13+ hex_frmt,
  [miscd^.target_style,miscd^.target_exstyle,miscd^.target_classstyle])[1]);
//  Show32bitText(dialog, IDC_BUTTON_STYLE, miscd^.target_style);
//  Show32bitText(dialog, IDC_BUTTON_EXSTYLE, miscd^.target_exstyle);
  //------------------------------------------------------------------------------
  Show32bitText(dialog, IDC_STATIC_PID, miscd^.target_PID);
  Show32bitText(dialog, IDC_STATIC_TID, miscd^.target_TID);
  Show32bitText(dialog, IDC_STATIC_WNDHANDLE, miscd^.target_handle);
  Show32bitText(dialog, IDC_STATIC_PARENTWND, miscd^.target_parenthandle);
  SetDlgItemText(dialog, IDC_STATIC_CLASSNAME, @miscd^.target_classname[0]);
  Show32bitText(dialog, IDC_STATIC_INSTANCE, miscd^.target_Instance);
  Show32bitText(dialog, IDC_STATIC_MENUNAME, miscd^.target_menuhandle);
  Show32bitText(dialog, IDC_STATIC_CTRLID, miscd^.target_ctrlid);
  Show32bitText(dialog, IDC_STATIC_WNDPROC, miscd^.target_wndproc);
  Show32bitText(dialog, IDC_STATIC_ICONHANDLE, miscd^.target_icon_big);
  Show32bitText(dialog, IDC_STATIC_ICONSMHANDLE, miscd^.target_icon_small);
  SetDlgItemText(dialog, IDC_STATIC_WINDOWRECT, @rectcoord2string(miscd^.target_windowrect)[1]);
  SetDlgItemText(dialog, IDC_STATIC_CLIENTRECT, @rectcoord2string(miscd^.target_clientrect)[1]);
  //------------------------------------------------------------------------------
  case miscd^.target_isvisible of
    true: CheckDlgButton(dialog, IDC_CHECK_ISVISIBLE, BST_CHECKED);
  else
    CheckDlgButton(dialog, IDC_CHECK_ISVISIBLE, BST_UNCHECKED);
  end;
  case miscd^.target_isunicode of
    true: CheckDlgButton(dialog, IDC_CHECK_ISUNICODE, BST_CHECKED);
  else
    CheckDlgButton(dialog, IDC_CHECK_ISUNICODE, BST_UNCHECKED);
  end;
  case miscd^.target_isenabled of
    true: CheckDlgButton(dialog, IDC_CHECK_ISENABLED, BST_CHECKED);
  else
    CheckDlgButton(dialog, IDC_CHECK_ISENABLED, BST_UNCHECKED);
  end;
  //------------------------------------------------------------------------------
end;

