(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros etc pp.                                                        ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

var
  Mouse_HookID: HHOOK;
  lastID: word;

function MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
(*
  Functionality:
    Hook callback function for a mouse hook (here a local mouse hook) to show
    hints for the controls above which the mouse pointer resides.
    [SPECIFIC]
*)
var
  miscd: PMiscData;
  s: string;
const
  IDTRYAGAIN = 10;
  IDCONTINUE = 11;
  IDTIMEOUT = 32000;
  IDC_STATIC = DWORD(-1);
begin
  case nCode < 0 of
    true:
      Result := CallNextHookEx(Mouse_HookID, nCode, wParam, lParam);
  else
    begin
      miscd := globrefpointer;
      if lastID <> GetDlgCtrlId(PMOUSEHOOKSTRUCT(lParam)^.HWND) then
        case GetDlgCtrlId(PMOUSEHOOKSTRUCT(lParam)^.HWND) of
//          IDC_TARGETER:
//            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_TARGETER[1]);
          IDC_BUTTON_STATUS:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_STATUS[1]);
          IDC_STATIC_PID:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_PID, [miscd^.target_PID])[1]);
          IDC_STATIC_TID:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_TID, [miscd^.target_TID])[1]);
          IDC_STATIC_WNDPROC:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_WNDPROC, [miscd^.target_wndproc])[1]);
          IDC_STATIC_WNDHANDLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_WNDHANDLE, [@szSC_hotkey[1]])[1]);
          IDC_STATIC_CLASSNAME:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_STATIC_CLASSNAME[1]);
          IDC_STATIC_CTRLID:
            begin
              case DWORD(miscd^.target_ctrlid) of
                IDOK: // 1
                  s := 'IDOK';
                IDCANCEL: //2
                  s := 'IDCANCEL';
                IDABORT: //3
                  s := 'IDABORT';
                IDRETRY: //4
                  s := 'IDRETRY';
                IDIGNORE: //5
                  s := 'IDIGNORE';
                IDYES: //6
                  s := 'IDYES';
                IDNO: //7
                  s := 'IDNO';
                IDCLOSE: //8
                  s := 'IDCLOSE';
                IDHELP: //9
                  s := 'IDHELP';
                IDTRYAGAIN: //10
                  s := 'IDTRYAGAIN';
                IDCONTINUE: //11
                  s := 'IDCONTINUE';
                IDTIMEOUT: //32000
                  s := 'IDTIMEOUT';
                IDC_STATIC: // -1
                  s := 'IDC_STATIC';
              else
                s := '{user-defined}';
              end;
              s := ' = ' + s;
              SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_CTRLID, [miscd^.target_ctrlid, @s[1]])[1]);
            end;
          IDC_STATIC_ICONHANDLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_ICONHANDLE, [miscd^.target_icon_big])[1]);
          IDC_STATIC_ICONSMHANDLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_ICONSMHANDLE, [miscd^.target_icon_small])[1]);
          IDC_STATIC_MENUNAME:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_MENUNAME, [miscd^.target_menuhandle])[1]);
          IDC_STATIC_INSTANCE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_INSTANCE, [miscd^.target_instance])[1]);
          IDC_STATIC_WINDOWRECT:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_STATIC_WINDOWRECT[1]);
          IDC_STATIC_CLIENTRECT:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_STATIC_CLIENTRECT[1]);
          IDC_STATIC_PARENTWND:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_STATIC_PARENTWND, [miscd^.target_parenthandle])[1]);
          IDC_BUTTON_STYLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_STYLE[1]);
          IDC_BUTTON_EXSTYLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_EXSTYLE[1]);
          IDC_BUTTON_CLOSETARGETWINDOW:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_CLOSETARGETWINDOW[1]);
          IDC_BUTTON_MINIMIZE_RESTORE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_MINIMIZE_RESTORE[1]);
          IDC_BUTTON_KILLTARGETPROCESS:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_KILLTARGETPROCESS[1]);
          IDC_BUTTON_WNDPROPS:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_BUTTON_WNDPROPS[1]);
          IDC_CHECK_ISVISIBLE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_CHECK_ISVISIBLE[1]);
          IDC_CHECK_ISUNICODE:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_CHECK_ISUNICODE[1]);
          IDC_CHECK_ISENABLED:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_CHECK_ISENABLED[1]);
          IDC_EDIT_ASSOCTEXT:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_EDIT_ASSOCTEXT[1]);
          IDC_CHECK_MAKEVIS:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @Format(hint_IDC_CHECK_MAKEVIS, [@szPW_hotkey[1]])[1]);
          IDC_CHECK_COPYCLIP:
            SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_IDC_CHECK_COPYCLIP[1]);
        else
          SetDlgItemText(maindlg, IDC_BUTTON_STATUS, @hint_ELSE[1]);
        end;
      lastID := GetDlgCtrlId(PMOUSEHOOKSTRUCT(lParam)^.HWND);
      Result := CallNextHookEx(Mouse_HookID, nCode, wParam, lParam);
    end;
  end;
end;

procedure InitHints;
(*
  Functionality:
    Initialises the local mouse hook and thus the hints.
    [SPECIFIC]
*)
begin
  Mouse_HookID := SetWindowsHookEx(WH_MOUSE, MouseProc, 0, GetCurrentThreadId());
end;

procedure DeinitHints;
(*
  Functionality:
    Finalises the local mouse hook and thus disables hints.
    [GENERIC]
*)
begin
  if Mouse_HookID <> 0 then
    UnHookWindowsHookEx(Mouse_HookID);
end;

